#!/usr/local/bin/perl
##############################################################################
# MP Form Mail CGI ProfessionalŁ@Ver2.2
# iCGI{́j
# Copyright(C) futomi 2001 - 2003
# http://www.futomi.com/
###############################################################################
use strict;
require './jcode.pl';
use CGI;
my $q = new CGI;
$| = 1;

#ݒf[^擾/`

my $MANUAL_CGIURL = '';
my $X_Mailer = 'MP Form Mail CGI Pro Ver2.1 (http://www.futomi.com/)';
my $MP_CONF = './conf/mpconfig.cgi';
my $ITEM_CONF = './conf/itemconfig.cgi';
my $CHECK_CONF = './conf/checkconfig.cgi';
my $CONFIRM_TEMP_FILE = './template/confirm.html';
my $MAIL_TEMP_FILE = './template/mail.txt';
my $REPLY_TEMP_FILE = './template/reply.txt';
my $ERROR_TEMP_FILE = './template/error.html';
my $ATTACHMENT_DIR = './attachment';

my %CONF = &GetConf($MP_CONF);

my @ALLOW_FROM_URLS = split(/\|/, $CONF{'ALLOW_FROM_URLS'});
my $ATTACHMENT_DEL_FLAG = $CONF{'ATTACHMENT_DEL_FLAG'};
my $ATTACHMENT_MAX_SIZE = $CONF{'ATTACHMENT_MAX_SIZE'};
my $CONFIRM_FLAG = $CONF{'CONFIRM_FLAG'};
my $DELIMITER = $CONF{'DELIMITER'};
my @EXT_RESTRICT = split(/\|/, $CONF{'EXT_RESTRICT'});
my $FORMAT_CUSTOM_FLAG = $CONF{'FORMAT_CUSTOM_FLAG'};
my $FROM = $CONF{'FROM'};
my $FROM_ADDR_FOR_REPLY = $CONF{'FROM_ADDR_FOR_REPLY'};
my $LOGING_FLAG = $CONF{'LOGING_FLAG'};
my $LOG_FORMAT = $CONF{'LOG_FORMAT'};
my $LOTATION = $CONF{'LOTATION'};
my $LOTATION_SIZE = $CONF{'LOTATION_SIZE'};
my $MAILTO = $CONF{'MAILTO'};
my $MAIL_HEADER_PLUS = $CONF{'MAIL_HEADER_PLUS'};
my $MAX_INPUT_CHAR = $CONF{'MAX_INPUT_CHAR'};
my $REDIRECT_URL = $CONF{'REDIRECT_URL'};
my $REJECT_ERR_MSG = $CONF{'REJECT_ERR_MSG'};
my @REJECT_HOSTS = split(/\|/, $CONF{'REJECT_HOSTS'});
my $REPLY_FLAG = $CONF{'REPLY_FLAG'};
my $SENDER_NAME_FOR_REPLY = $CONF{'SENDER_NAME_FOR_REPLY'};
my $REPLY_CC_OPTION = $CONF{'REPLY_CC_OPTION'};
my $SENDMAIL = $CONF{'SENDMAIL'};
my $SIRIAL_FLAG = $CONF{'SIRIAL_FLAG'};
my $SUBJECT = $CONF{'SUBJECT'};
my $SUBJECT_FOR_REPLY = $CONF{'SUBJECT_FOR_REPLY'};
my $WRAP = $CONF{'WRAP'};

my %ITEM_CONF = &GetConf($ITEM_CONF);
my @NECESSARY_NAMES = ();
my %CONVERT_RULES = ();
my %INPUT_RESTRICTIONS = ();
my @DataNames = ();
my %DispNames = ();
my $key;
for $key (sort{$a<=>$b} keys %ITEM_CONF) {
	my($name, $necessary_flag, $convert_str, $restrict_str, $disp_name) = split(/<>/, $ITEM_CONF{$key});
	if($necessary_flag) {
		push(@NECESSARY_NAMES, $name);
	}
	$CONVERT_RULES{$name} = $convert_str;
	$INPUT_RESTRICTIONS{$name} = $restrict_str;
	push(@DataNames, $name);
	$DispNames{$name} = $disp_name;
}

my %INPUT_RESTRICTIONS_ERR = (
	'1'  => '$NAME$́ApŎw肵ĂB',
	'2'  => '$NAME$́ASpŎw肵ĂB',
	'3'  => '$NAME$́ApAt@xbgŎw肵ĂB',
	'4'  => '$NAME$́ASpAt@xbgŎw肵ĂB',
	'5'  => '$NAME$́AppŎw肵ĂB',
	'6'  => '$NAME$́ASppŎw肵ĂB',
	'7'  => '$NAME$́A܂B',
	'11' => '$NAME$́AnCtȂ̔p10Ŏw肵ĂB',
	'12' => '$NAME$́AnCt10̔pŎw肵ĂB',
	'13' => '$NAME$́AnCtȂ̔p11Ŏw肵ĂB',
	'14' => '$NAME$́AnCt11̔pŎw肵ĂB',
	'15' => '$NAME$́AnCtȂ̔p11Ŏw肵ĂB',
	'16' => '$NAME$́AnCt11̔pŎw肵ĂB',
	'17' => '$NAME$́AnCtȂ1011̔pŎw肵ĂB',
	'18' => '$NAME$́AnCt1011̔pŎw肵ĂB',
	'21' => '$NAME$́AnCtȂŔp7Ŏw肵ĂB',
	'22' => '$NAME$́AnCtĔp7Ŏw肵ĂB',
	'23' => '$NAME$́Ap3Ŏw肵ĂB',
	'24' => '$NAME$́Ap4Ŏw肵ĂB',
	'31' => '$NAME$́ASpЂ炪ȂŎw肵ĂB',
	'32' => '$NAME$́ASpJ^JiŎw肵ĂB'
);

my %CHECK_CONF = &GetConf($CHECK_CONF);
my @EQUALITY_CHECK_LIST = ();
my $name;
for $name (keys %CHECK_CONF) {
	my($name2, $err) = split(/,/, $CHECK_CONF{$name});
	push(@EQUALITY_CHECK_LIST, "$name,$name2,$err");
}

# ^CX^vp̓擾
# $Stamp: Oo͗p
# $SendDate: M[p
my($Stamp, $SendDate) = &GetDate;


my $LOGFILE;
if($LOTATION eq '0') {
	$LOGFILE = './logs/maillog.cgi';
} elsif($LOTATION eq '1') {
	my $day = substr($Stamp, 0, 8);
	$LOGFILE = "./logs/maillog\.$day\.cgi";
} elsif($LOTATION eq '2') {
	my $mon = substr($Stamp, 0, 6);
	$LOGFILE = "./logs/maillog\.$mon\.cgi";
} else {
	$LOGFILE = './logs/maillog.cgi';
}



# Base64GR[he[u
my $Base64Table = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
	           'abcdefghijklmnopqrstuvwxyz'.
	           '0123456789+/';


# OT[o̗p֎~
&ExternalRequestCheck;

# wzXg̃ANZXO
my $HostName = &GetHostName($ENV{'REMOTE_ADDR'});
&RejectHostAccess($HostName);

# tH[f[^擾,M[{AmFʗpHIDDEN^O
my $Message = '';
my %EucValues = ();
my @EucNames = ();
my @HiddenTags = ();
# Ytt@C݂ΓYtt@CZbg
my @names = $q->param;
my @AttachNames = ();
my $AttachmentFlag = 0;
for my $name (@names) {
	if($name =~ /^attachment[0-9]*$/) {
		my $value = $q->param($name);
		if($value ne '') {
			push(@AttachNames, $name);
			$AttachmentFlag ++;
		}
	}
}
my $Status = $q->param('status');

# VAԍ𐶐
my $SirialNo;
if($SIRIAL_FLAG) {$SirialNo = &MakeSirial;}

if($SIRIAL_FLAG) {
	$Message = "yVAԍz\n";
	$Message .= "$SirialNo\n\n";
}

for $key (@DataNames) {
	if($key eq 'status') {next;}
	my @DataTmpList = $q->param($key);
	my $ItemNum = scalar @DataTmpList;
	my $key_code = &jcode::getcode(\$key);
	&jcode::convert(\$key, "sjis", "$key_code");
	$Message .= "y$DispNames{$key}z\n";
	my $value = '';
	my $SelectedItem;
	for $SelectedItem (@DataTmpList) {
		if($ItemNum > 1) {
			unless($SelectedItem) {
				next;
			}
		}
		my $value_code = &jcode::getcode(\$SelectedItem);
		&jcode::convert(\$SelectedItem, "sjis", "$value_code");
		unless($key eq 'attachment') {
			if($MAX_INPUT_CHAR && length($SelectedItem) > $MAX_INPUT_CHAR) {
				&ErrorPrint("͕́Ap$MAX_INPUT_CHAR܂łłB");
			}
		}
		if(exists $CONVERT_RULES{$key}) {	#͒lϊ
			$SelectedItem = &ValueConvert($SelectedItem, $CONVERT_RULES{$key});
		}
		$Message .= "$SelectedItem\n";
		$value .= "$SelectedItem ";
		$SelectedItem =~ s/\</&lt;/g;
		$SelectedItem =~ s/\>/&gt;/g;
		$SelectedItem =~ s/\"/&quot;/g;
		my $HiddenTag = '<input type="hidden" name="' . $key . '" value="' . $SelectedItem . '">';
		push(@HiddenTags, $HiddenTag);
	}
	$value =~ s/ $//;
	&jcode::convert(\$value, "euc", "sjis");
	my $euckey = $key;
	&jcode::convert(\$euckey, "euc", "sjis");
	push(@EucNames, $euckey);
	$EucValues{$euckey} = $value;

	# bZ[W̉sR[h𓝈ꂷ
	$Message = &UnifyReturnCode($Message);
	$Message .= "\n";
}
push(@HiddenTags, '<input type="hidden" name="status" value="1">');

# K{ڂI͓͂Ă邩̃`FbN
&NecessaryCheck(\%EucValues, \@NECESSARY_NAMES);

#͒l`FbN
&InputRestrict(\%EucValues);

# ē̓`FbNB
if(scalar @EQUALITY_CHECK_LIST) {
	&EqualityCheck(\%EucValues);
}

# nameumailaddressv݂̂̂Ȃ΁AԐM̃tOOFFɂB
unless($EucValues{'mailaddress'}) {
	$REPLY_FLAG = 0;
}

# tH[ɁAnameumailaddressv̂̂΁A
# M[AhXDIɐݒ肷B
my $FromFlag = 0;
my $FromTmp = $EucValues{'mailaddress'};
if($FromTmp) {
	$FROM = $FromTmp;
	$FromFlag = 1;
}

# tH[ɁAnameusubjectv̂̂΁A
# M[TuWFNgDIɐݒ肷B
my($SubjectTmp) = $q->param('subject');
if($SubjectTmp) {$SUBJECT = $SubjectTmp;}

# TuWFNgɁAtH[͒lϊwqΕϊB
&jcode::convert(\$SUBJECT, 'euc');
for $key (keys %EucValues) {
	$SUBJECT =~ s/\$$key\$/$EucValues{$key}/g;
	$SUBJECT =~ s/<!--$key-->/$EucValues{$key}/g;
}

# Ytt@C΁At@C𒊏oA
# e|[t@C𐶐B
my %AttacheData = ();
if($AttachmentFlag) {
	my @files = ();
	for my $aname (@AttachNames) {
		my $FullFileName = $q->param($aname);
		my $AttachContentType = $q->uploadInfo($FullFileName)->{'Content-Type'};
		my $tmp = $FullFileName;
		&jcode::convert(\$tmp, 'euc');
		my @TempList = split(/\\/, $tmp);
		my $AttachmentFileName = pop(@TempList);
		&jcode::convert(\$AttachmentFileName, 'sjis');
		# gq`FbN
		if(scalar @EXT_RESTRICT) {
			my @FileNameParts = split(/\./, $AttachmentFileName);
			my $ext = pop(@FileNameParts);
			unless(grep(/$ext$/i, @EXT_RESTRICT)) {
				for my $file (@files) {
					unlink($file);
				}
				&ErrorPrint("w̃t@C𑗐M邱Ƃ͂ł܂B");
			}
		}
	
		$ATTACHMENT_DIR =~ s/\/$//;
		$ATTACHMENT_DIR .= '/';
		my $AttachmentFile = $ATTACHMENT_DIR.$AttachmentFileName;
		open(OUTFILE, ">$AttachmentFile") || &ErrorPrint("Ytt@C̃e|[t@C[$AttachmentFile]̍쐬Ɏs܂B:$!");
		my $bytesread;
		my $buffer;
		while($bytesread=read($FullFileName, $buffer, 1024)) {
			print OUTFILE $buffer;
		}
		close(OUTFILE);
	
		# Ytt@CTCỸ`FbN
		my $AttachmentFileSize = -s $AttachmentFile;
		if($AttachmentFileSize > $ATTACHMENT_MAX_SIZE) {
			unlink($AttachmentFile);
			for my $file (@files) {
				unlink($file);
			}
			&ErrorPrint("$ATTACHMENT_MAX_SIZEoCgȏ̃t@C͓Ytł܂B");
		}

		$AttacheData{$aname} = [$AttachmentFile, $AttachmentFileName, $AttachContentType];
		push(@files, $AttachmentFile);
	}
}


if($CONFIRM_FLAG && $AttachmentFlag == 0 && $Status eq '') {
	&PrintConfirm;
	exit;
} else {
	&MailSend;
}

# ԐM[𑗐M
if($REPLY_FLAG && $FromFlag) {
	&Reply($REPLY_TEMP_FILE);
}

# tH[f[^Oɏo
if($LOGING_FLAG) {
	&Loging(\@EucNames, \%EucValues);
}

# Ytt@C폜
if($AttachmentFlag && $ATTACHMENT_DEL_FLAG) {
	for my $aname (@AttachNames) {
		my $file = $AttacheData{$aname}->[0];
		unlink($file);
	}
}

# _CNg
select(STDOUT);
print "Location: $REDIRECT_URL\n\n";

exit;


######################################################################
# Tu[`
######################################################################

# K{ڂI͓͂Ă邩̃`FbN
sub NecessaryCheck {
	my($EucValues, $NecessaryNames) = @_;
	my($Name, $NoData);
	my @EucNecessaryNames = ();
	for $Name (@$NecessaryNames) {
		&jcode::convert(\$Name, "euc");
		push(@EucNecessaryNames, $Name);
	}
	my @NoDataList = ();
	my $NoDataCnt = 0;
	for $Name (@EucNecessaryNames) {
		if($$EucValues{$Name} eq '') {
			push(@NoDataList, $Name);
			$NoDataCnt ++;
		}
	}
	if($NoDataCnt) {
		my $ErrorString = 'ȉ̍ڂ͕K{łB';
		$ErrorString .= "<ul>\n";
		for $NoData (@NoDataList) {
			&jcode::convert(\$NoData, "sjis");
			$ErrorString .= " <li>$DispNames{$NoData}</li>\n";
		}
		$ErrorString .= "</ul>\n";
		&ErrorPrint($ErrorString);
	}
}


#͒lϊ
sub ValueConvert {
	my($value, $rule_str) = @_;
	my @rules = split(/,/, $rule_str);
	my $rule;
	for $rule (@rules) {
		if($rule eq '1') {		#SpƑSpnCt𔼊pɕϊ
			&jcode::tr(\$value, 'OPQRSTUVWX|', '0123456789-');
		} elsif($rule eq '2') {	#pƔpnCtSpɕϊ
			&jcode::tr(\$value, '0123456789-', 'OPQRSTUVWX|');
		} elsif($rule eq '3') {	#SpEpnCt폜
			my $zen_hyphen = '|';
			&jcode::convert(\$zen_hyphen, 'euc', 'sjis');
			&jcode::convert(\$value, 'euc', 'sjis');
			$value =~ s/$zen_hyphen//g;
			&jcode::convert(\$value, 'sjis', 'euc');
			$value =~ s/\-//g;
		} elsif($rule eq '4') {	#SpAt@xbg𔼊pɕϊ
			&jcode::tr(\$value, '`abcdefghijklmnopqrstuvwxy', 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ');
		} elsif($rule eq '5') {	#pAt@xbgSpɕϊ
			&jcode::tr(\$value, 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ', '`abcdefghijklmnopqrstuvwxy');
		} elsif($rule eq '6') {	#pJiSpJiɕϊ
			&jcode::h2z_sjis(\$value);
		} elsif($rule eq '7') {	#[AhX𔼊pɕϊ
			&jcode::tr(\$value, '`abcdefghijklmnopqrstuvwxy', 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ');
			&jcode::tr(\$value, 'OPQRSTUVWX|Q', '0123456789-_');
			$value =~ s//\@/g;
			$value =~ s/D/\./g;
		}
	}
	return $value;
}

#͒l`FbN
sub InputRestrict {
	my($values_ref) = @_;
	my $key;
	for $key (keys %INPUT_RESTRICTIONS) {
		my $euc_key = $key;
		&jcode::convert(\$euc_key, 'euc', 'sjis');
		my $value = $values_ref->{$euc_key};
		unless($value) {next;}
		my $value_len;
		$value_len = length($value);
		my @rules = split(/,/, $INPUT_RESTRICTIONS{$key});
		my $err_no;
		my $rule;
		for $rule (@rules) {
			
			if($rule eq '1') {				#p̂
				if($value =~ /[^0-9]/) {
					$err_no = $rule;
				}
			} elsif($rule eq '2') {			#Sp̂
				$value =~ s/\xa3[\xb0-\xbf]//g;
				if($value) {
					$err_no = $rule;
				}
			} elsif($rule eq '3') {			#pAt@xbĝ
				if($value =~ /[^a-zA-Z]/) {
					$err_no = $rule;
				}
			} elsif($rule eq '4') {			#SpAt@xbĝ
				$value =~ s/\xa3[\xc0-\xff]//g;
				if($value) {
					$err_no = $rule;
				}
			} elsif($rule eq '5') {			#pp̂
				if($value =~ /[^0-9a-zA-Z]/) {
					$err_no = $rule;
				}
			} elsif($rule eq '6') {			#Spp̂
				$value =~ s/\xa3[\xb0-\xff]//g;
				if($value) {
					$err_no = $rule;
				}
			} elsif($rule eq '7') {			#[AhX
				if($value =~ /[^a-zA-Z0-9\@\.\-\_]/) {
					$err_no = $rule;
				}
				unless($value =~ /^[^\@]+\@[^\@]+$/) {
					$err_no = $rule;
				}
				if($value =~ /\.$/) {
					$err_no = $rule;
				}
			} elsif($rule eq '11') {		#nCtȂ̌ŒdbipjiF0312345678j
				unless($value =~ /^0[0-9]{9}$/) {
					$err_no = $rule;
				}
			} elsif($rule eq '12') {		#nCťŒԍipjiF03-1234-5678j
				unless($value =~ /^0[0-9]+\-[0-9]+\-[0-9]+$/) {
					$err_no = $rule;
				}
				unless($value_len == 12) {
					$err_no = $rule;
				}
			} elsif($rule eq '13') {		#nCtȂ̌gѓdbipjiF09012345678j
				unless($value =~ /^090[0-9]{8}$/) {
					$err_no = $rule;
				}
			} elsif($rule eq '14') {		#nCťgѓdbipjiF090-1234-5678j
				unless($value =~ /^090\-[0-9]+\-[0-9]+$/) {
					$err_no = $rule;
				}
				unless($value_len == 13) {
					$err_no = $rule;
				}
			} elsif($rule eq '15') {		#nCtȂ̂ogr@ipjiF07012345678j
				unless($value =~ /^070[0-9]{8}$/) {
					$err_no = $rule;
				}
			} elsif($rule eq '16') {		#nCt̂ogr@ipjiF070-1234-5678j
				unless($value =~ /^070\-[0-9]+\-[0-9]+$/) {
					$err_no = $rule;
				}
				unless($value_len == 13) {
					$err_no = $rule;
				}
			} elsif($rule eq '17') {		#nCtȂ̓dbSʁipj
				if($value =~ /[^0-9]/) {
					$err_no = $rule;
				}
				if($value_len > 11 || $value_len < 10) {
					$err_no = $rule;
				}
			} elsif($rule eq '18') {		#nCt̓dbSʁipj
				unless($value =~ /^0[0-9]+\-[0-9]+\-[0-9]+$/) {
					$err_no = $rule;
				}
				if($value_len > 13 || $value_len < 12) {
					$err_no = $rule;
				}
			} elsif($rule eq '21') {		#nCtȂ̗X֔ԍipjiF1234567j
				unless($value =~ /^[0-9]{7}$/) {
					$err_no = $rule;
				}
			} elsif($rule eq '22') {		#nCt̗X֔ԍipjiF123-4567j
				unless($value =~ /^[0-9]{3}\-[0-9]{4}$/) {
					$err_no = $rule;
				}
			} elsif($rule eq '23') {		#p3iX֔ԍ̑Oj
				unless($value =~ /^[0-9]{3}$/) {
					$err_no = $rule;
				}
			} elsif($rule eq '24') {		#p4iX֔ԍ̌㔼j
				unless($value =~ /^[0-9]{4}$/) {
					$err_no = $rule;
				}
			} elsif($rule eq '31') {		#SpЂ炪Ȃ̂
				$value =~ s/(\xa4[\xa0-\xff]||\xa1\xbc)//g;
				if($value) {
					$err_no = $rule;
				}
			} elsif($rule eq '32') {		#SpJ^Jî
				$value =~ s/(\xa5[\xa0-\xff]|\xa1\xbc)//g;
				if($value) {
					$err_no = $rule;
				}
			}
			if($err_no) {
				my $err_msg = $INPUT_RESTRICTIONS_ERR{$rule};
				$err_msg =~ s/\$NAME\$/$DispNames{$key}/g;
				&ErrorPrint("$err_msg");
			}
		}
		
	}
}


#ē̓`FbN
sub EqualityCheck {
	my($values_ref) = @_;
	my $data;
	for $data (@EQUALITY_CHECK_LIST) {
		my($name1, $name2, $msg) = split(/,/, $data);
		unless($values_ref->{$name1} eq $values_ref->{$name2}) {
			&ErrorPrint("$msg");
		}
	}
}

# mFʂ\
sub PrintConfirm {

	# CGIURL肷B
	my $CgiUrl;
	if($MANUAL_CGIURL =~ /^http/) {
		$CgiUrl = $MANUAL_CGIURL;
	} else {
		$CgiUrl = &GetCgiUrl;
	}

	#Hidden^O̃XJ[ϐɊi[B
	my($Hidden) = join("\n", @HiddenTags);
		
	my $filesize = -s $CONFIRM_TEMP_FILE;
	if(!open(TEMP, "$CONFIRM_TEMP_FILE")) {
		&ErrorPrint("mFʗpev[gHTMLt@Ci$CONFIRM_TEMP_FILEjI[vł܂łB");
		exit;
	}
	binmode(TEMP);
	my $HtmlData;
	sysread(TEMP, $HtmlData, $filesize);
	close(TEMP);
	my $HiddenFlag = 0;
	my $CgiUrlFlag = 0;
	if($HtmlData =~ /<!--hidden-->/ || $HtmlData =~ /\$hidden\$/) {
		$HtmlData =~ s/\$hidden\$/$Hidden/;
		$HtmlData =~ s/<!--hidden-->/$Hidden/;
		$HiddenFlag = 1;
	}
	unless($HiddenFlag) {
		&ErrorPrint("mFʗpev[gHTMLt@Ci$CONFIRM_TEMP_FILEjɁA\$hidden\$ ܂ &lt;!--hidden--&gt; LڂĂ܂B");
	}
	$HtmlData =~ s/\$cgiurl\$/$CgiUrl/;
	$HtmlData =~ s/<!--cgiurl-->/$CgiUrl/;
	&jcode::convert(\$HtmlData, "euc");
	my $EucName;
	for $EucName (keys(%EucValues)) {
		my $EucValue;
		$EucValue = $EucValues{$EucName};
		$EucValue =~ s/\</&lt;/g;
		$EucValue =~ s/\>/&gt;/g;
		$EucValue =~ s/\"/&quot;/g;
		$EucValue =~ s/\n/<br>/g;
		unless($EucValue) {
			$EucValue = '&nbsp;';
		}
		$HtmlData =~ s/\$$EucName\$/$EucValue/g;
		$HtmlData =~ s/<!--$EucName-->/$EucValue/g;
	}

	&jcode::convert(\$HtmlData, "sjis");
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$HtmlData\n";
	exit;

}

# [𑗐M
sub MailSend {
	# Mҏ[{ɒǉ
	$Message .= "yMҏz\n";
	$Message .= "  EuEU[      : $ENV{'HTTP_USER_AGENT'}\n";
	$Message .= "  EMIPAhX: $ENV{'REMOTE_ADDR'}\n";
	$Message .= "  EMzXg  : $HostName\n";
	$Message .= "  EM        : $SendDate\n";

	if($FORMAT_CUSTOM_FLAG) {
		$Message = &CustomizeMail(\@EucNames, \%EucValues);
	}

	# bZ[W[hbv
	if($WRAP >= 50) {
		$Message = &WordWrap($Message);
	}

	# bZ[WJISɕϊ
	&jcode::convert(\$Message, "jis");
	
	# [^CgBase64 BGR[h
	$SUBJECT = &EncodeSubject($SUBJECT);
	
	# [M
	open(SENDMAIL, "|$SENDMAIL -t");
	select(SENDMAIL);
	print "To: $MAILTO\n";
	print "From: $FROM\n";
	print "Subject: $SUBJECT\n";
	print "X-Mailer: $X_Mailer\n";

	if($MAIL_HEADER_PLUS) {
		$MAIL_HEADER_PLUS =~s/\n+$//;
		print "$MAIL_HEADER_PLUS\n";
	}
	print "MIME-Version: 1.0\n";

	my $boundary = &GenerateBoundary($Message);
	if($AttachmentFlag) {
		print 'Content-Type: multipart/mixed;',"\n";
		print "	boundary=\"$boundary\"\n";
		print "Content-Transfer-Encoding: 7bit\n";
		print "\n";
		print "--$boundary\n";
	}
	print "Content-Type: text/plain\; charset=iso-2022-jp\n";
	print "Content-Transfer-Encoding: 7bit\n";
	print "\n";
	print "$Message\n";
	print "\n";

	if($AttachmentFlag) {
		for my $aname (@AttachNames) {
			my $file_path = $AttacheData{$aname}->[0];
			my $file_name = $AttacheData{$aname}->[1];
			my $content_type = $AttacheData{$aname}->[2];
			#t@CBase64 B GR[h
			$file_name = &EncodeSubject($file_name);
			#Ytt@CBase64GR[h
			my $base64_data = &Base64Encode($file_path);
			print "--$boundary\n";
			print "Content-Type: $content_type;\n";
			print " name=\"$file_name\"\n";
			print "Content-Disposition: attachment;\n";
			print " filename=\"$file_name\"\n";
			print "Content-Transfer-Encoding: base64\n";
			print "\n";
			print "$base64_data\n";
			print "\n";
		}
		print "--$boundary--";
	}
	close(SENDMAIL);
}


sub CustomizeMail {
	my($EucNames, $EucValues) = @_;
	my $size = -s $MAIL_TEMP_FILE;
	if(!open(IN, "$MAIL_TEMP_FILE")) {
		&ErrorPrint("ev[gt@CI[vł܂łB: $!");
		exit;
	}
	my $buf;
	sysread(IN, $buf, $size);
	close(IN);
	&jcode::convert(\$buf, 'euc');
	my $key;
	for $key (@$EucNames) {
		$buf =~ s/\$$key\$/$EucValues->{$key}/g;
		$buf =~ s/<!--$key-->/$EucValues->{$key}/g;
	}
	$buf =~ s/\$USERAGENT\$/$ENV{'HTTP_USER_AGENT'}/g;
	$buf =~ s/\$REMOTE_ADDR\$/$ENV{'REMOTE_ADDR'}/g;
	$buf =~ s/\$REMOTE_HOST\$/$HostName/g;
	$buf =~ s/\$DATE\$/$SendDate/g;
	$buf =~ s/\$SIRIAL\$/$SirialNo/ig;

	$buf =~ s/<!--USERAGENT-->/$ENV{'HTTP_USER_AGENT'}/g;
	$buf =~ s/<!--REMOTE_ADDR-->/$ENV{'REMOTE_ADDR'}/g;
	$buf =~ s/<!--REMOTE_HOST-->/$HostName/g;
	$buf =~ s/<!--DATE-->/$SendDate/g;
	$buf =~ s/<!--SIRIAL-->/$SirialNo/ig;
	$buf = &UnifyReturnCode($buf);
	&jcode::convert(\$buf, 'sjis', 'euc');
	return $buf;
}


# tH[f[^Oɏo
sub Loging {
	my($EucNames, $EucValues) = @_;
	my($key, $LogString, $DelimiterChar);
	if($DELIMITER == 2) {
		$DelimiterChar = ' ';
	} elsif($DELIMITER == 3) {
		$DelimiterChar = "\t";
	} else {
		$DelimiterChar = ",";
	}

	my($ValueBuff);
	$LogString .= "$Stamp$DelimiterChar";
	if($SIRIAL_FLAG) {
		$LogString .= "$SirialNo$DelimiterChar";
	}
	for $key (@$EucNames) {
		if($LOG_FORMAT) {$LogString .= "$key=";}
		$ValueBuff = $$EucValues{$key};
		if($DELIMITER == 2) {
			$ValueBuff = &EucZenSpace($ValueBuff);	#pXy[XEUCSpXy[Xɕϊ
		} elsif($DELIMITER == 3) {
			$ValueBuff =~ s/\t//g;
		} else {
			$ValueBuff = &EucZenKanma($ValueBuff);	#pJ}EUCSpJ}ɕϊ
		}

		$LogString .= "$ValueBuff";
		$LogString .= $DelimiterChar;
	}
	$LogString .= "$ENV{'REMOTE_ADDR'}$DelimiterChar$HostName$DelimiterChar$ENV{'HTTP_USER_AGENT'}";


	$LogString = &UnifyReturnCode($LogString);	#sR[hu\nvɓꂷ
	$LogString =~ s/\n/<br>/g;	#sR[h<br>ɕϊ
	&jcode::convert(\$LogString, "sjis");	#SJISɕϊ

	if($LOTATION eq '9') {
		if(-e "$LOGFILE") {
			my $logsize = -s $LOGFILE;
			if($logsize >= $LOTATION_SIZE) {
				my $day = substr($Stamp, 0, 8);
				my $new_filename;
				my $cnt = 0;
				while(1) {
					if($cnt == 0) {
						$new_filename = "./logs/maillog\.$day\.cgi";
					} else {
						$new_filename = "./logs/maillog\.$day\-$cnt\.cgi";
					}
					unless(-e "$new_filename") {
						last;
					}
					$cnt ++;
					if($cnt >= 100) {
						&ErrorPrint("[vG[ : Ot@CɎs܂B");
					}
				}
				rename($LOGFILE, $new_filename) || &ErrorPrint("O[e[VɎs܂B: $!");
			}
		}
	}

	open(LOGFILE, ">>$LOGFILE") || &ErrorPrint("Ot@CI[vł܂łB");
	my $lock_result = &Lock(*LOGFILE);
	if($lock_result) {
		&ErrorPrint("AݍĂ܂B΂炭Ă炨B: $lock_result");;
	}
	print LOGFILE "$LogString\n";
	close(LOGFILE);
}


# ԐM[𑗐M
sub Reply {
	my($ReplyTempFile) = @_;
	my($key, $Value, $Message);
	# ev[gt@C̕ $MessageɊi[
	if(!open(IN, "$ReplyTempFile")) {
		&ErrorPrint("ev[gt@CI[vł܂łB: $!");
		exit;
	}
	my $size = -s $ReplyTempFile;
	sysread(IN, $Message, $size);
	close(IN);
	# bZ[W̉sR[h𓝈ꂷ
	$Message = &UnifyReturnCode($Message);
	# ϊ̂߂ɁAbZ[WEUCɕϊ
	&jcode::convert(\$Message, "euc");
	# ϊ
	my($value);
	for $key (keys(%EucValues)) {
		$value = $EucValues{$key};
		$value = &UnifyReturnCode($value);
		$Message =~ s/\$$key\$/$value/g;
		$Message =~ s/<!--$key-->/$value/g;
		if($SIRIAL_FLAG) {
			$Message =~ s/\$SIRIAL\$/$SirialNo/ig;
			$Message =~ s/<!--SIRIAL-->/$SirialNo/ig;
		}
	}
	# bZ[W[hbv
	if($WRAP >= 50) {
		$Message = &WordWrap($Message);
	}
	# [M̂߂ɁAbZ[WJISɕϊ
	&jcode::convert(\$Message, "jis");
	# [^CgBase64 BGR[h
	$SUBJECT_FOR_REPLY = &EncodeSubject($SUBJECT_FOR_REPLY);
	# FromsGR[h
	my $FromLine = $FROM_ADDR_FOR_REPLY;
	if($SENDER_NAME_FOR_REPLY) {
		$FromLine = &EncodeFrom($SENDER_NAME_FOR_REPLY, $FROM_ADDR_FOR_REPLY);
	}
	# ԐM[M
	open(SENDMAIL, "|$SENDMAIL -t");
	select(SENDMAIL);
	print "To: $FROM\n";
	if($REPLY_CC_OPTION eq '1') {
		print "Cc: $MAILTO\n";
	} elsif($REPLY_CC_OPTION eq '2') {
		print "Bcc: $MAILTO\n";
	}
	print "From: $FromLine\n";
	print "Subject: $SUBJECT_FOR_REPLY\n";
	print "X-Mailer: $X_Mailer\n";
	print "MIME-Version: 1.0\n";
	print "Content-Type: text/plain\; charset=iso-2022-jp\n";
	print "Content-Transfer-Encoding: 7bit\n";
	print "\n";
	print "$Message\n";
	close(SENDMAIL);
}


# FromsGR[h
sub EncodeFrom {
	my($Str, $FromAddr) = @_;
	my $EncStr = &EncodeSubject($Str);
	my @TmpArray = split(/\n/, $EncStr);
	my $Tmp = pop(@TmpArray);
	if(length($Tmp) + length($FromAddr) + 3 > 75) {
		$EncStr .= "\n";
	}
	$EncStr .= " <$FromAddr>";
	return $EncStr;
}

sub ErrorPrint {
	my($msg) = @_;
	unless(-e $ERROR_TEMP_FILE) {
		&ErrorPrint2("ev[gt@C $ERROR_TEMP_FILE ܂B: $!");
	}
	my $size = -s $ERROR_TEMP_FILE;
	if(!open(FILE, "$ERROR_TEMP_FILE")) {
		&ErrorPrint2("ev[gt@C <tt>$ERROR_TEMP_FILE</tt> I[vł܂łB : $!");
		exit;
	}
	binmode(FILE);
	my $html;
	sysread(FILE, $html, $size);
	close(FILE);
	$html =~ s/\$ERROR\$/$msg/gi;
	$html =~ s/<!--error-->/$msg/gi;
	select(STDOUT);
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$html\n";
	exit;
}

sub ErrorPrint2 {
	my($msg) = @_;
	select(STDOUT);
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print "$msg\n";
	exit;
}

# ݂̃^CX^vԂ
sub GetDate {
	my($sec, $min, $hour, $mday, $mon, $year, $wday) = localtime(time);
	$year += 1900;
	$mon += 1;
	$mon = "0$mon" if($mon < 10);
	$mday = "0$mday" if($mday < 10);
	$hour = "0$hour" if($hour < 10);
	$min = "0$min" if($min < 10);
	$sec = "0$sec" if($sec < 10);
	my @WeekDayList = ('', '', '', '', '', '', 'y');
	my $DispStamp = "$yearN$mon$mdayi$WeekDayList[$wday]j $hour:$min:$sec";
	my $Stamp = $year.$mon.$mday.$hour.$min.$sec;
	return $Stamp,$DispStamp;
}

# VAԍ𐶐
sub MakeSirial {
	my($Sirial) = "$Stamp-";
	my(@IpAddr) = split(/\./, $ENV{'REMOTE_ADDR'});
	my($key, $part);
	for $key (@IpAddr) {
		if($key < 10) {
			$part = "00$key";
		} elsif($key < 100) {
			$part = "0$key";
		} else {
			$part = $key;
		}
		$Sirial .= $part;
	}
	return $Sirial;
}


sub GetHostName {
	my($ip_address) = @_;
	my(@addr) = split(/\./, $ip_address);
	my($packed_addr) = pack("C4", $addr[0], $addr[1], $addr[2], $addr[3]);
	my($name, $aliases, $addrtype, $length, @addrs);
	($name, $aliases, $addrtype, $length, @addrs) = gethostbyaddr($packed_addr, 2);
	return $name;
}

# sR[h \n ɓ
sub UnifyReturnCode {
	my($String) = @_;
	$String =~ s/\x0D\x0A/\n/g;
	$String =~ s/\x0D/\n/g;
	$String =~ s/\x0A/\n/g;
	return $String;
}

# MIME Multipartp̋E𐶐
sub GenerateBoundary {
	my($BodyString) = @_;
	my(@Lines) = split(/\n/, $BodyString);
	my($Boundary, $Buff, $i, $Line);
	my($Flag) = 1;
	while($Flag) {
		$Boundary = '';
		for ($i=0;$i<20;$i++) {
			if($i % 5 == 0 && $i != 0) {$Boundary .= '_';}
			srand;
			$Boundary .= substr($Base64Table, int(rand(60)), 1);
		}
		$Boundary .= '_'.time;
		$Flag = 0;
		for $Line (@Lines) {
			if($Line =~ /$Boundary/) {$Flag = 1; last;}
		}
	}
	return $Boundary;
}

# Ytt@CBase64GR[h
sub Base64Encode {
	my($File) = @_;
	my($MaxCharNum) = 76;	#Ps̒̕`

	my($FileSize) = -s "$File";
	my($Data);
	open(FILE, "$File");
	read FILE, $Data, $FileSize;
	close(FILE);

	my($EncodedData, $chunk, $ByteChunk, $PackedByteChunk, $DecimalNum);
	my($BitStream) = unpack("B*", $Data);

	my $i = 0;
	while($chunk = substr($BitStream, $i*6, 6)) {
		unless(length($chunk) == 6) {
			$chunk = pack("B6", $chunk);
			$chunk = unpack("B6", $chunk);
		}
		$ByteChunk = sprintf("%08d", $chunk);
		$PackedByteChunk = pack("B8", $ByteChunk);
		$DecimalNum = unpack("C", $PackedByteChunk);
		$EncodedData .= substr($Base64Table, $DecimalNum, 1);
		$i++;
	}

	my($PadNum) = 3 - ($FileSize % 3);
	if($PadNum == 1) {
		$EncodedData .= '=';
	} elsif($PadNum == 2) {
		$EncodedData .= '==';
	}

	my($ReformedData, $LineString);
	$i = 0;
	while($LineString = substr($EncodedData, $i*$MaxCharNum, $MaxCharNum)) {
		$ReformedData .= $LineString."\n";
		$i ++;
	}
	$ReformedData =~ s/\n$//;
	return $ReformedData;
}

#[TuWFNgBase64 BGR[h
sub EncodeSubject {
	my($String) = @_;
	&jcode::convert(\$String, "euc");
	my($Base64Table) = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'.
	                      'abcdefghijklmnopqrstuvwxyz'.
	                      '0123456789+/';
	my($chunk, $ByteChunk, $PackedByteChunk, $DecimalNum, $EncodedString);
	my($SplitedWord, @SplitedWordList, $i, $Byte, $Buff, $BitStream);
	my($KI) = 0;
	my($KO) = 0;
	my($CharNum) = 0;
	my($CharType) = 0;
	my($LineLength) = 0;
	my($CharEndFlag) = 1;
	if($String =~ /[^a-zA-Z0-9\!\"\#\$\%\&\'\(\)\*\+\,\-\.\/\:\;\<\=\>\?\@\[\/\^\_\~ ]/) {
		$i = 0;
		@SplitedWordList = ();
		while($i < length($String)) {
			$Byte = substr($String, $i, 1);
			if($Byte =~ /[\x8E\xA1-\xFE]/) {
				unless($CharType eq 'K') {$KI ++;}
				$CharType = 'K';
				if($CharEndFlag) {
					$CharEndFlag = 0;
				} else {
					$CharEndFlag = 1;
				}
			} else {
				if($CharType eq 'K') {$KO ++;}
				$CharType = 'A';
				$CharEndFlag = 1;
			}
			$Buff .= $Byte;
			$CharNum += 1;
			$LineLength = 27 + ($CharNum*4/3) + (($KI+$KO)*4) + 2;
			if($CharType eq 'K') {$LineLength += 4;}
			if($CharEndFlag && $LineLength>=70) {
				&jcode::convert(\$Buff, "jis");
				push(@SplitedWordList, $Buff);
				$Buff = '';
				$CharNum = 0;
				$CharType = 0;
				$KI = 0;
				$KO = 0;
			}
			$i ++;
		}
		&jcode::convert(\$Buff, "jis");
		push(@SplitedWordList, $Buff);

		for $SplitedWord (@SplitedWordList) {
			$EncodedString .= '=?ISO-2022-JP?B?';
			$BitStream = unpack("B*", $SplitedWord);
			$i = 0;
			while($chunk = substr($BitStream, $i*6, 6)) {
				unless(length($chunk) == 6) {
					$chunk = pack("B6", $chunk);
					$chunk = unpack("B6", $chunk);
				}
				$ByteChunk = sprintf("%08d", $chunk);
				$PackedByteChunk = pack("B8", $ByteChunk);
				$DecimalNum = unpack("C", $PackedByteChunk);
				$EncodedString .= substr($Base64Table, $DecimalNum, 1);
				$i++;
			}
			if(length($SplitedWord) % 3 == 1) {
				$EncodedString .= '==';
			} elsif(length($SplitedWord) % 3 == 2) {
				$EncodedString .= '=';
			}
			$EncodedString .= '?='."\n ";
		}
		$EncodedString =~ s/\n $//;
	} else {
		$EncodedString = $String;
	}
	return $EncodedString;
}

sub EucZenKanma {
	my($Value) = @_;
	my $EucZenKanma = 'C';
	&jcode::convert(\$EucZenKanma, "euc");
	$Value =~ s/,/$EucZenKanma/g;
	return $Value;
}

sub EucZenSpace {
	my($Value) = @_;
	my $EucZenSpace = '@';
	&jcode::convert(\$EucZenSpace, "euc");
	$Value =~ s/ /$EucZenSpace/g;
	return $Value;
}


sub Lock {
	local(*FILE) = @_;
	eval{flock(FILE, 2)};
	if($@) {
		return $!;
	} else {
		return '';
	}
}

sub GetRemoteHost {
	my($remote_host);
	if($ENV{'REMOTE_HOST'} =~ /[^0-9\.]/) {
		$remote_host = $ENV{'REMOTE_HOST'};
	} else {
		my(@addr) = split(/\./, $ENV{'REMOTE_ADDR'});
		my($packed_addr) = pack("C4", $addr[0], $addr[1], $addr[2], $addr[3]);
		my($aliases, $addrtype, $length, @addrs);
		($remote_host, $aliases, $addrtype, $length, @addrs) = gethostbyaddr($packed_addr, 2);
		unless($remote_host) {
			$remote_host = $ENV{'REMOTE_ADDR'};
		}
	}
	return $remote_host;
}


sub ExternalRequestCheck {
	my $url;
	if(scalar @ALLOW_FROM_URLS) {
		my $flag = 0;
		for $url (@ALLOW_FROM_URLS) {
			if($ENV{'HTTP_REFERER'} =~ /^$url/) {
				$flag = 1;
			}
		}
		unless($flag) {
			&ErrorPrint("sȃT[õNGXgłB");
		}
	}


}

sub GetCgiUrl {
	return "mpmail.cgi";
}

sub RejectHostAccess {
	my($HostName) = @_;
	my($Reject);
	my $RejectFlag = 0;
	if(scalar @REJECT_HOSTS) {
		for $Reject (@REJECT_HOSTS) {
			if($Reject =~ /[^0-9\.]/) {	# zXgw̏ꍇ
				if($HostName =~ /$Reject$/) {
					$RejectFlag = 1;
					last;
				}
			} else {	# IPAhXw̏ꍇ
				if($ENV{'REMOTE_ADDR'} =~ /^$Reject/) {
					$RejectFlag = 1;
					last;
				}
			}
		}
		if($RejectFlag) {
			&ErrorPrint("$REJECT_ERR_MSG");
			exit;
		}
	}
}


sub WordWrap {
	my($Str) = @_;
	&jcode::convert(\$Str, 'euc');

	my $WrapedStr = '';
	my $LineLength = 0;
	my($word, $WordLength);
	my(@SplitedWords, $buff, $byte, $i, @Words, @WordParts, $part);
	my @Lines = split(/\n/, $Str);
	my $line;
	my $KanjiFlag = 0;
	my $KanjiFirstByteFlag = 1;
	for $line (@Lines) {
		@Words = split(/ /, $line);
		for $word (@Words) {
			@WordParts = ();
			$i = 0;
			$KanjiFirstByteFlag = 1;
			$part = '';
			while($i <= length($word) - 1) {
				$byte = substr($word, $i, 1);
				if($byte =~ /[\x8E\xA1-\xFE]/) {	#{
					unless($KanjiFlag) {
						push(@WordParts, $part);
						$part = '';
						$KanjiFirstByteFlag = 1;
						$KanjiFlag = 1;
					}
					$part .= "$byte";
					if($KanjiFirstByteFlag) {
						$KanjiFirstByteFlag = 0;
					} else {
						$KanjiFirstByteFlag = 1;
						push(@WordParts, $part);
						$part = '';
					}
				} else {				#p
					if($KanjiFlag) {
						$part = '';
					}
					$part .= "$byte";
					if($byte =~ /^(\-|\/)$/) {
						push(@WordParts, $part);
						$part = '';
					}
					$KanjiFlag = 0;
					$KanjiFirstByteFlag = 1;
				}
				$i ++;
			}
			push(@WordParts, $part);
			for $part (@WordParts) {
				if($LineLength + length($part) > $WRAP) {
					$WrapedStr .= "\n";
					$LineLength = 0;
				}
				$WrapedStr .= "$part";
				$LineLength += length($part);
			}
			$WrapedStr .= " ";
			$LineLength += 1;
		}
		$WrapedStr .= "\n";
		$LineLength = 0;
	}
	return $WrapedStr;
}

sub GetConf {
	my($file) = @_;
	my %data = ();
	open(FILE, "$file") || &ErrorPrint("ݒt@C <tt>$file</tt> I[vł܂łB: $!");
	while(<FILE>) {
		chop;
		my $line = $_;
		unless($line) {next;}
		if($line =~ /^\s*\#/) {next;}
		my($key, $value) = split(/=/, $line);
		unless($key) {next;}
		$key =~ s/^[\s\t]*//;
		$key =~ s/[\s\t]*$//;
		$value =~ s/^[\s\t]*//;
		$value =~ s/[\s\t]*$//;
		$data{$key} = $value;
	}
	close(FILE);
	return %data;
}

